# JA4+

JA4+ is a suite of network fingerprinting methods.

## Nomenclature

Name | Meaning
--- | ---
JA4 | TLS client fingerprint
JA4S | TLS server fingerprint
JA4L-C/S | Light distance/location fingerprint
JA4H | HTTP client fingerprint
JA4SSH | SSH traffic fingerprint
JA4X | X.509 fingerprint

## Requirements

You must install tshark (wireshark.org) and add the folder for tshark to your system PATH  
(System properties > Environment Variables... > Edit Path)

## Usage

```
Usage: ja4 [OPTIONS] <PCAP>

Arguments:
  <PCAP>
          The capture file to process

Options:
  -j, --json
          JSON output (default is YAML)

  -r, --with-raw
          Include raw (unhashed) fingerprints in the output

  -O, --original-order
          Preserve the original order of values.

          JA4 (TLS client): disable sorting of ciphers and TLS extensions.

          JA4H (HTTP client): disable sorting of headers and cookies.

      --keylog-file <KEYLOG_FILE>
          The key log file that enables decryption of TLS traffic.

          This file is generated by the browser when `SSLKEYLOGFILE` environment variable is set. See <https://wiki.wireshark.org/TLS#using-the-pre-master-secret> for more details.

          Note that you can embed the TLS key log file in a capture file: `editcap --inject-secrets tls,keys.txt in.pcap out-dsb.pcapng`

  -n, --with-packet-numbers
          Include packet numbers (`pkt_*` fields) in the output.

          This information is useful for debugging.

  -h, --help
          Print help (see a summary with '-h')

  -V, --version
          Print version
```

# JA4X

`ja4x` CLI utility reads X.509 certificate files, DER or PEM encoded, and prints JA4X fingerprints, Issuer, and Subject information.

## Usage

```
Print JA4X fingerprints of X.509 certificates

Usage: ja4x [OPTIONS] [CERTS]...

Arguments:
  [CERTS]...  X.509 certificate(s)

Options:
  -j, --json      JSON output (default is YAML)
  -r, --with-raw  Include raw (unhashed) fingerprints in the output
  -h, --help      Print help
  -V, --version   Print version
```

## Sample output

```
path: sample.pem
ja4x: a373a9f83c6b_2bab15409345_7bf9a7bf7029
issuerCountryName: US
issuerOrganizationName: DigiCert Inc
issuerCommonName: DigiCert TLS RSA SHA256 2020 CA1
subjectCountryName: US
subjectStateOrProvinceName: California
subjectLocalityName: San Francisco
subjectOrganizationName: Cisco OpenDNS LLC
subjectCommonName: api.opendns.com
```
